diff --git a/lib/bpf_legacy.c b/lib/bpf_legacy.c
index 4fabdcc899e4..8ac642358969 100644
--- a/lib/bpf_legacy.c
+++ b/lib/bpf_legacy.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * bpf.c	BPF common code
  *
- *		This program is free software; you can distribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Daniel Borkmann <daniel@iogearbox.net>
  *		Jiri Pirko <jiri@resnulli.us>
  *		Alexei Starovoitov <ast@kernel.org>
diff --git a/lib/cg_map.c b/lib/cg_map.c
index 39f244dbc5bd..e5d14d512c39 100644
--- a/lib/cg_map.c
+++ b/lib/cg_map.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * cg_map.c	cgroup v2 cache
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Dmitry Yakunin <zeil@yandex-team.ru>
  */
 
diff --git a/lib/fs.c b/lib/fs.c
index 3752931cf8f8..22d4af7583dd 100644
--- a/lib/fs.c
+++ b/lib/fs.c
@@ -1,13 +1,8 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * fs.c         filesystem APIs
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	David Ahern <dsa@cumulusnetworks.com>
- *
  */
 
 #include <sys/types.h>
diff --git a/lib/inet_proto.c b/lib/inet_proto.c
index 41e2e8b88d82..71cd3b128841 100644
--- a/lib/inet_proto.c
+++ b/lib/inet_proto.c
@@ -1,13 +1,8 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * inet_proto.c
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
- *
  */
 
 #include <stdio.h>
diff --git a/lib/json_print.c b/lib/json_print.c
index 741acdcff990..d7ee76b10de8 100644
--- a/lib/json_print.c
+++ b/lib/json_print.c
@@ -1,10 +1,6 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
- * json_print.c		"print regular or json output, based on json_writer".
- *
- *             This program is free software; you can redistribute it and/or
- *             modify it under the terms of the GNU General Public License
- *             as published by the Free Software Foundation; either version
- *             2 of the License, or (at your option) any later version.
+ * json_print.c	 - print regular or json output, based on json_writer
  *
  * Authors:    Julien Fortin, <julien@cumulusnetworks.com>
  */
diff --git a/lib/libnetlink.c b/lib/libnetlink.c
index 001efc1d7f24..c89760436aba 100644
--- a/lib/libnetlink.c
+++ b/lib/libnetlink.c
@@ -1,13 +1,8 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * libnetlink.c	RTnetlink service routines.
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
- *
  */
 
 #include <stdio.h>
diff --git a/lib/ll_addr.c b/lib/ll_addr.c
index d6fd736b1e3a..5e9245915ef3 100644
--- a/lib/ll_addr.c
+++ b/lib/ll_addr.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * ll_addr.c
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
  */
 
diff --git a/lib/ll_map.c b/lib/ll_map.c
index 70ea3d499c8f..8970c20f3cdd 100644
--- a/lib/ll_map.c
+++ b/lib/ll_map.c
@@ -1,13 +1,8 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * ll_map.c
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
- *
  */
 
 #include <stdio.h>
diff --git a/lib/ll_proto.c b/lib/ll_proto.c
index 925e2caa05e5..526e582fbbba 100644
--- a/lib/ll_proto.c
+++ b/lib/ll_proto.c
@@ -1,10 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * ll_proto.c
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
  *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
  */
diff --git a/lib/ll_types.c b/lib/ll_types.c
index 49da15df911d..fa57ceb5c3b8 100644
--- a/lib/ll_types.c
+++ b/lib/ll_types.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * ll_types.c
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
  */
 
diff --git a/lib/names.c b/lib/names.c
index b46ea7910946..cbfa971ff61b 100644
--- a/lib/names.c
+++ b/lib/names.c
@@ -1,11 +1,6 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * names.c		db names
- *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  */
 
 #include <stdio.h>
diff --git a/lib/namespace.c b/lib/namespace.c
index 45a7deddb6c4..1202fa85f97d 100644
--- a/lib/namespace.c
+++ b/lib/namespace.c
@@ -1,10 +1,6 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * namespace.c
- *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
  */
 
 #include <sys/statvfs.h>
diff --git a/lib/rt_names.c b/lib/rt_names.c
index b976471d7979..2432224acc0a 100644
--- a/lib/rt_names.c
+++ b/lib/rt_names.c
@@ -1,11 +1,7 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * rt_names.c		rtnetlink names DB.
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
  */
 
diff --git a/lib/utils.c b/lib/utils.c
index dd3cdb31239c..b740531ab6c9 100644
--- a/lib/utils.c
+++ b/lib/utils.c
@@ -1,13 +1,8 @@
+/* SPDX-License-Identifier: GPL-2.0-or-later */
 /*
  * utils.c
  *
- *		This program is free software; you can redistribute it and/or
- *		modify it under the terms of the GNU General Public License
- *		as published by the Free Software Foundation; either version
- *		2 of the License, or (at your option) any later version.
- *
  * Authors:	Alexey Kuznetsov, <kuznet@ms2.inr.ac.ru>
- *
  */
 
 #include <stdio.h>